float4   cnt    : register(c0);

struct VS_OUTPUT {
  float4 pos : POSITION;
  float4 tex : TEXCOORD0;
};

//̂܂psɓn
VS_OUTPUT vs_main(VS_OUTPUT input) {
  return input;
}

float iso(float3 p) {
  float  x = cos(p.x) * 2;
  float  y = (p.y);
  float  z = (p.z);
  float3 ip = float3(20, 25, 16);
  float r = cos(x) + cos(y) + cos(z);
  r -= log( sin(p.x) - sin(p.y * 5) - sin(p.z * 5)) * 0.01;
  p *= ip;
  r -= ( sin(p.x) - sin(p.y) - sin(p.z)) * 0.03;
  return r;
}

float cast(float3 eye, float3 dir, float th) {
  float dt = 8;
  float t = 0;
  for(int i = 0; i < 100 && dt > 0.003; i++) {
    float3 temp = eye + dir * t;
    if(iso(temp) < th) {
      t -= dt;
      dt *= 0.25;
    }
    t += dt;
  }
  return t;
}


float4 ps_main(float2 uv:texcoord) : color {
  float time = cnt.x;
  if(uv.y < -0.7 || uv.y > 0.7) return 0;
  float rotate = (time + sin(time * 0.1)) * 0.1;
  float3x3 mtx = {
    cos(rotate),  sin(rotate), 0,
    sin(rotate), -cos(rotate), 0,
    0,           0,            1
  };
  
  //rotate ray direction
  float3 dir    = normalize(float3(uv.x * 1.25, uv.y, 0.5));
  dir           = mul(mtx, dir).zxy;
  dir           = mul(mtx, dir) / 16;
  
  //cast
  float3 eye    = float3(sin(time * 0.5), time, 0);
  float  t      = cast(eye, dir,  0.3);
  
  //calc normal.
  float3 ip     = eye + dir * t;
  float  iit    = iso(ip);
  float3 h      = float3(0.01, 0, 0);
  float3 n      = normalize(float3( iit - iso(ip + h.xyy), iit - iso(ip + h.yxy), iit - iso(ip + h.yyx)));
  
  //light.
  float3 light  = normalize(float3(1,  -0.5,  1));
  float3 normal = dot(light, n);
  
  //iro
  float  len    = distance(eye + dir * t, eye);
  float4 col    = float4((dir * 0.5) + float3(.1, .3, .8) * normal, 1) + t * 0.002;
  return col;
  
}
